package main;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.ImageProducer;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;

public class Mains extends Thread {

	public static void main(String[] args) {
		for(int i=0; i < args.length; i++) {
			mode_debug = args[i].equals("-debug")?true:mode_debug;
			mode_nodisplay = args[i].equals("-nodisplay")?true:mode_nodisplay;
		}
		new Mains().start();
	}

	private static boolean mode_debug = false;
	private static boolean mode_nodisplay = false;

	private int yukki;
	private int yukkiLove;
	private JLabel yukkiLabel;
	private JLabel yukkiLoveLabel;
	private boolean isUp = true; // false : down

	private JPanel panel;

	private JPanel moviePanel; // panelの中の右上に配置されたパネルのポインタを入れる
	private final void setMoviePanel(JPanel p) {this.moviePanel = p;}

	public static final int
		XPOS = 100,
		YPOS = 50,
		WIDTH = 600,
		HEIGHT = 400;
	public static final Color
		COLOR_N_GREY = new Color(100, 100, 100),
		COLOR_L_GREY = new Color(200, 200, 200),
		COLOR_D_GREY = new Color(50, 50, 50);
	public static final Font
		FONT_PLAIN_S = new Font("monospace", Font.PLAIN, 20),
		FONT_PLAIN_M = new Font("monospace", Font.PLAIN, 30),
		FONT_PLAIN_L = new Font("monospace", Font.PLAIN, 40),
		FONT_BOLD_S = new Font("monospace", Font.BOLD, 20),
		FONT_BOLD_M = new Font("monospace", Font.BOLD, 30),
		FONT_BOLD_L = new Font("monospace", Font.BOLD, 40);

	@Override
	public void run() {
		while(true && !mode_nodisplay) {
			try {
				moviePanel.repaint();
				Thread.sleep(16);
			}catch(InterruptedException e) {}
		}
	}
	public Mains() {
		// macボタンの色白くなる対策
		try{
			   UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		}catch(Exception e){
			  e.printStackTrace();
		}
		panel = new JPanel() {
			{
				this.setLayout(null);
				this.setBounds(0, 0, Mains.WIDTH, Mains.HEIGHT);
				this.setBackground(Mains.COLOR_D_GREY);
			}
		};
		int maj = 20;
		// 左
		panel.add(new JPanel() {{
			this.setLayout(null);
			this.setBounds(maj, maj, Mains.WIDTH/2-maj-24, Mains.HEIGHT-maj*2-38);
			this.setBackground(Mains.COLOR_N_GREY);
			this.add(new JButton() {
				{
					addOrSub();
					this.setBounds(maj, maj, maj*4, maj*2);
					this.setFocusPainted(false);
					this.setBorderPainted(true);
					this.setContentAreaFilled(false);
					this.setFont(Mains.FONT_PLAIN_S);
					this.setForeground(Mains.COLOR_L_GREY);
					this.addActionListener(new ActionListener() {
						@Override
						public void actionPerformed(ActionEvent e) {
							isUp=isUp?false:true;
							if(mode_debug) System.out.println("CountMode : " + isUp);
							addOrSub();
						}
					});
				}
				private final void addOrSub() {this.setText(isUp?"＋":"－");}
			});
			this.add(new JButton() {{
				this.setLayout(null);
				this.setFocusPainted(false);
				this.setBorderPainted(true);
				this.setContentAreaFilled(true);
				this.setBackground(Mains.COLOR_N_GREY);
				this.setOpaque(true); // おそらく透過(?)でmac対策
				this.setFont(Mains.FONT_PLAIN_M);
				this.setForeground(Mains.COLOR_L_GREY);
				this.setText("ゆっきー");
				this.setBounds(maj, maj+maj*4, Mains.WIDTH/2-maj-24-maj*2, maj*2*2);
				this.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						countYukki();
					}
				});
			}});
			this.add(new JButton() {{
				this.setLayout(null);
				this.setFocusPainted(false);
				this.setContentAreaFilled(true);
				this.setBackground(Mains.COLOR_N_GREY);
				this.setOpaque(true); // おそらく透過(?)でmac対策
				this.setFont(Mains.FONT_PLAIN_M);
				this.setForeground(Mains.COLOR_L_GREY);
				this.setText("ゆっきーラブ");
				this.setBounds(maj, maj+maj*4+maj*2*2+maj,  Mains.WIDTH/2-maj-24-maj*2, maj*2*2);
				this.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						countYukkiLove();
					}
				});
			}});
		}});
		// 右
		yukkiLabel = new JLabel() {{
			this.setBounds(10, 0, Mains.WIDTH/2-maj*2-24-maj*2+maj, 60);
			this.setFont(Mains.FONT_BOLD_S);
		}};
		yukkiLoveLabel = new JLabel() {{
			this.setBounds(10, 60, Mains.WIDTH/2-maj*2-24-maj*2+maj, 60);
			this.setFont(Mains.FONT_BOLD_S);
		}};
		panel.add(new JPanel() {{ // 上
			this.setLayout(null);
			this.setBounds(Mains.WIDTH/2+maj, maj, Mains.WIDTH/2-maj*2-24+maj, Mains.HEIGHT-maj*2-38);
			this.setBackground(Mains.COLOR_N_GREY);
			this.add(new JPanel() {
				{
					this.setLayout(null);
					this.setBounds(maj, maj, Mains.WIDTH/2-maj*2-24-maj*2+maj, (Mains.HEIGHT-maj*2)/2-38-maj);
					this.setBackground(Mains.COLOR_L_GREY);
					setMoviePanel(this);
				}
				@Override
				public void paintComponent(Graphics g) {super.paintComponent(g); if(!mode_nodisplay)actionMovie((Graphics2D)g);}
			});
			this.add(new JPanel() {{ // 下
				this.setLayout(null);
				this.setBounds(maj, maj + (Mains.HEIGHT-maj*2)/2-38-maj+maj, Mains.WIDTH/2-maj*2-24-maj*2+maj, (Mains.HEIGHT-maj*2)/2-38);
				this.setBackground(Mains.COLOR_L_GREY);
				this.add(yukkiLabel);
				this.add(yukkiLoveLabel);
			}});
		}});
		updateYukkiCount();

		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(Mains.WIDTH, Mains.HEIGHT);
		frame.setResizable(false);
		frame.setLocation(Mains.XPOS, Mains.YPOS);
		frame.setContentPane(panel);
		Image image;
		try {
			URL url = frame.getClass().getResource("/res/icon.png");
			image = frame.createImage((ImageProducer)url.getContent());
			frame.setIconImage(image);
		}catch(Exception e) {
			e.printStackTrace();
		}
		frame.setVisible(true);
	}
	private final void countYukki() {
		yukki = isUp?yukki+1:yukki<=0?0:yukki-1;
		updateYukkiCount();
		cyclingPatt();
		if(mode_debug) System.out.println("YukkiCount : " + yukki);
	}
	private final void countYukkiLove() {
		yukkiLove = isUp?yukkiLove+1:yukkiLove<=0?0:yukkiLove-1;
		updateYukkiCount();
		cyclingPatt();
		if(mode_debug) System.out.println("YukkiLoveCount : " + yukkiLove);
	}

	private final void updateYukkiCount() {
		yukkiLabel.setText("<html>ゆっきー : <br>" + yukki+"</html>");
		yukkiLoveLabel.setText("<html>ゆっきーラブ : <br>" + yukkiLove+"</html>");
	}

	private float
		m_xp=0.0f,
		m_yp=0.0f,
		m_ti=0.0f,
		m_dx=0.03f,
		m_cycleSize=0.0f;
	private int
		m_num = 10,
		m_cyclePtt = 0;
	private final void cyclingPatt() {
		m_cyclePtt = m_cyclePtt>=2?0:m_cyclePtt+1;
		if(mode_debug) System.out.println("CyclePttern :" + m_cyclePtt);
		m_cycleSize = 15.0f;
	}
	private final void actionMovie(Graphics2D g) {
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		for(int i=0; i < m_num; i++) {
			m_xp = moviePanel.getWidth()/2.0f+
				(50.0f+m_cycleSize)*(float)Math.sin(
					Math.PI*2.0*
					(m_cyclePtt==0?1.0:m_cyclePtt==1?2.0:m_cyclePtt==2?3.0:0.0)*
					(float)i/m_num+m_ti
				);
			m_yp = moviePanel.getHeight()/2.0f+
				(30.0f+m_cycleSize)*(float)Math.cos(
					Math.PI*2.0*
					(m_cyclePtt==0?1.0:m_cyclePtt==1?1.0:m_cyclePtt==2?2.0:0.0)*
					(float)i/m_num+m_ti
				);
			if(i%2==0) g.drawString("ゆっきー", m_xp, m_yp);
			if(i%2==1) g.drawString("ラブ", m_xp, m_yp);
		}
		m_cycleSize = m_cycleSize>0.0f?m_cycleSize-0.5f:0.0f;
		m_ti+=m_dx;
	}
}
